#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

#include "absdiff.h"

AbsdiffFilter::AbsdiffFilter() {
  lastimage = NULL;
  outputimage = NULL;
  outputimage2 = NULL;
  threshold_value = 0;
}

AbsdiffFilter::~AbsdiffFilter() {
  cerr << "-- AbsdiffFilter::~AbsdiffFilter\n";
  
  if(lastimage!=NULL) {
    fprintf(stderr,"   freeing lastimage[0x%x]\n",lastimage);
    free(lastimage);
  }

   if(outputimage!=NULL) {
    fprintf(stderr,"   freeing outputimage[0x%x]\n",outputimage);
    free(outputimage);
  }

   if(outputimage2!=NULL) {
     fprintf(stderr,"   freeing outputimage2[0x%x]\n",outputimage2);
     free(outputimage2);
   }
}

bool AbsdiffFilter::init() {
  unsigned char *curypos;
  int i;
  
  lastimage=(unsigned char *)malloc(size);
   if(lastimage==NULL) {
    fprintf(stderr," ! out of memory allocating lastimage sized[%u]\n",size);
    return(false);
  } else
    fprintf(stderr,"   allocated lastimage[0x%x] sized[%u]\n",lastimage,size);
   
  outputimage=(unsigned char *)malloc(size);
  if(outputimage=NULL) {
    fprintf(stderr," ! out of memory allocating lastimage sized[%u]\n",size);
    return(false);
  } else
    fprintf(stderr,"   allocated outputimage[0x%x] sized[%u]\n",outputimage,size);
  
  
  outputimage2=(unsigned char *)malloc(size);
  if(outputimage2=NULL) {
    fprintf(stderr," ! out of memory allocating lastimage sized[%u]\n",size);
    return(false);
  } else
    fprintf(stderr,"   allocated outputimage[0x%x] sized[%u]\n",outputimage2,size);
  
  procbuf=(unsigned char *)malloc(size);
  if(procbuf=NULL) {
     fprintf(stderr," ! out of memory allocating lastimage sized[%u]\n",size);
    return(false);
  } else
    fprintf(stderr,"   allocated outputimage[0x%x] sized[%u]\n",procbuf,size);

  /* Initialize color space conversion tables */
  /* Y 8bit to RGB 16bit */
  if ((y8_to_rgb565=(unsigned char *)malloc(256*sizeof(short)))==NULL) {
    perror("malloc");
  }
  curypos=y8_to_rgb565;
  for (i=0; i<256; i++) {  
    *curypos=((i >> 3) << 11 ) | ((i >> 2) << 5) | (i >> 3);
    curypos++; 
  }

}

unsigned char *AbsdiffFilter::process(unsigned char *buffo) {
  int i;

  absdiff(buffo,lastimage,outputimage,size);

  if(threshold_value>0)
    threshold(outputimage, outputimage2, size, threshold_value);
  
  memcpy((unsigned char*)lastimage,(unsigned char *)buffo,size);

  if(threshold_value>0)
    curposframe=outputimage2;
  else
    curposframe=outputimage;
  
  for(i=0;i<size;i++)
    procbuf[i] = y8_to_rgb565[(int) curposframe[i]];
  
  return(procbuf);
}
