#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include "strobe.h"

StrobeFilter::StrobeFilter() {
  storebuf = NULL;
  frame_count = 0;
  delay = 15; /* default delay */
}

StrobeFilter::~StrobeFilter() {
  cerr << "-- StrobeFilter::~StrobeFilter\n";
  if(storebuf!=NULL) {
    fprintf(stderr,"   unmapping buffer[0x%x]\n",storebuf);
    free(storebuf);
  }
}

bool StrobeFilter::init() {
  cerr << "-- StrobeFilter::init\n";

  storebuf = (unsigned char*)malloc(size);

  if(storebuf==NULL)
    return(false);
  
  fprintf(stderr,"  allocated storebuf[0x%x] sized[%u]\n",storebuf,size);
}

unsigned char *StrobeFilter::process(unsigned char *buffo) {
  frame_count++;

  if(frame_count>delay) {
    memcpy(storebuf,buffo,size);
    frame_count = 0;
  }

  return(storebuf);
}

void StrobeFilter::set_delay(int num) {
  delay = num;
  frame_count = 0;
}
