#ifndef __context_h__
#define __context_h__

#include <SDL.h>
#include <iostream.h>

class Context {
 private:
  /* fps calculation stuff */
  double _time();
  
  double cur_time;
  double lst_time;
  int fps_frame_interval;
  int framecount;
  /* --------------------- */

 public:

  Context(int w, int h, int bppx, Uint32 flags);
  ~Context();

  bool flip();

  /* this returns a pointer to the video memory */
  unsigned char *get_surface();

  SDL_Surface *surf;
  SDL_VideoInfo *Info;

  int w, h;
  int size;
  int bpp;

  /* ---- fps ---- */
  bool calc_fps();
  /* Set the interval (in frames) after which the fps counter is updated */
  void set_fps_interval(int interval);
  void print_fps();
  float fps;
};

#endif
