#ifndef __LAYER_H__
#define __LAYER_H__

#include <context.h>
#include <filter.h>
#include <assert.h>
#include <SDL.h>

class Layer {
 public:
  Layer() { };
  ~Layer() { };

  /* these two must be defined into layer instances
     otherwise the compiler complains (pure virtual funcs) */
  virtual bool feed() = 0;
  virtual bool blit(unsigned char *dest) = 0;

  virtual bool add_filter(Filter *newfilt);
  Filter *filter;

  /* Set the interval (in frames) after which the fps counter is updated */
  void set_fps_interval(int interval);
  bool calc_fps();
  void print_fps();
  float fps;

  Context *screen;

  int w;
  int h;
  int bpp;
  long size;
};

#endif
