#ifndef __v4l_h__
#define __v4l_h_

/* this to avoid g++ complaining about videodev.h */
#define ulong __u32

#include <linux/types.h>
#include <linux/videodev.h>
#include <SDL_thread.h>
#include <layer.h>

class V4lGrabber: public Layer {
 private:
  int dev;
  int input;
  int norm;
  Uint32 palette;

  struct video_capability grab_cap;

  struct video_mbuf grab_map;
  struct video_mmap grab_buf[2];
  int cur_frame;
  int ok_frame;
  int num_frame;

  struct video_channel grab_chan;
  struct video_picture grab_pic;

  bool grab24;
  bool have_tuner;
  int minw, minh, maxw, maxh;

  unsigned char *get_buffer();

 public:
  V4lGrabber();
  ~V4lGrabber();
  bool detect(char *devfile);
  bool init(Context *screen);
  bool feed();
  bool blit(unsigned char *dest);

  unsigned char *buffer;
  char *device;

};

#endif
